#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <fcntl.h>
#include <stdio.h>

// SIGUSR1 = 0
// SIGUSR2 = 1

volatile int can = 0;
int pid = 0;

void accept(int sig) {
  signal(SIGUSR1, accept);
  can = 1;
}

void send(int x) {
  int i;
  for(i = 128; i>0; i /= 2) {
    if((x-i) >= 0) {
      x -= i;
      kill(pid, SIGUSR2);
    } else {
      kill(pid, SIGUSR1);
    }
    while(can == 0)
      pause(); // wait for reply
    can = 0;
  }
  kill(pid, SIGUSR1); // ending signal
  while(can == 0)
    pause(); // wait for reply
  can = 0;
}

int main(int argc, char *argv[])
{
  int fd, i;
  unsigned char buf;

  if(argc != 2) {
    printf("Usage:\n");
    printf("semr and semw are used together. Run semr with file ");
    printf("name as argument. Both programs after run writes their PID, which");
    printf(" you must supply to the other one.\n");
    printf("semr will then read the file and using SIGUSR1 and SIGUSR2 ");
    printf("will send the contents of file to semw, that will echo it on ");
    printf("screen.\n");
    exit(1);
  }

  signal(SIGUSR1, accept);
  printf("PID: %d\nWrite PID of semwrite: ", getpid());
  while(pid == 0)
    scanf("%d", &pid);

  if ((fd = open(argv[1], O_RDONLY)) < 0) {
    printf("\nCan't read file %s\n", argv[1]);
    exit(1);
  }

  while(can == 0)
    pause(); // wait for reply
  can = 0;

  while(read(fd, &buf, 1)==1) {
    printf("read: %c\n", buf);
    send(buf);
  }

  for(i=0; i<9; i++) {
    kill(pid, SIGUSR2);
  }

  close(fd);
  exit(0);
}